



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>js程序设计01——基本概念</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">js程序设计01——基本概念</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 01:41:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文为js高级程序设计学习笔记，笔记中不乏本人学习js的一些心得demo，喜欢的朋友可以直接参考原书&ldquo;javascript高级程序设计&rdquo;，写本笔记的目的是对js中容易出错、不易理解的地方作个笔记，以免后期继续踩坑。</p>
<p><strong>1、语法</strong></p>
<ul><li>区分大小写：比如typeof用于测试数据类型，不同于typeOf，一个func完全可以定义为typeOf</li>
<li>标识符：首字符必须是字母、下划线或$，之后可以是数字、字母、下划线或$；标识符不能使用系统关键字及保留字，比如var、true、false、null、let等</li>
<li>严格模式：</li></ul>
<p>严格模式是ECMAScript 5中引入的概念，是为js定义解析以及执行模型的一种机制，也是为了兼容旧版本的ECMAScript版本而引入的，就是一种编译指示，可以确定ECMAScript 3版本编译运行时的一些不确定行为。使用"use strict"，方法如下：</p>
<div>
<pre class="prettyprint linenums">function say(){<br />
  "use strict";<br />
  console.log("hello strict mode");<br />
}

say();</pre>
</div>
<p><strong>2、变量</strong></p>
<p><strong>所有未经初始化的变量始终为undefined</strong>，不论变量类型：</p>
<div>
<pre class="prettyprint linenums">function say(){<br />
  var message = "hello message";<br />
}<br />
say();<br />
alert(message);  //message未定义为undefined</pre>
</div>
<p><strong>但是如果省略了var关键字，则message自动上升为全局变量</strong>，不会报错：</p>
<div>
<pre class="prettyprint linenums">function say(){<br />
  message = "hello message";<br />
}<br />
say();<br />
console.log(message);</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/798032/201609/798032-20160926103332641-41412745.png" /></p>
<p><strong>变量声明初始化允许同时进行</strong>，比如：</p>
<div>
<pre class="prettyprint linenums">var m1 = "1",m2 = "2",m3 = [1,2,3];<br />
console.log(m1);<br />
console.log(m2);<br />
console.log(m3);</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/798032/201609/798032-20160926103547375-777329833.png" /></p>
<p><strong>3、数据类型</strong></p>
<p>ECMAScript 5定义js有5中基本类型+1种复杂数据类型（引用类型），<strong>基本类型：Undefined、Null、Boolean、Number、String，复杂类型：Object</strong>。</p>
<p>其中typeof操作符是用来测试数据类型的，typeof的返回值可以是如下几种：</p>
<div>
<pre class="prettyprint linenums">&ldquo;undefined&rdquo;&mdash;&mdash;唯一的Undefined类型值，表示&ldquo;未定义&rdquo;；<br />
&ldquo;boolean&rdquo;&mdash;&mdash;对于Boolean的true or false返回；<br />
&ldquo;string&rdquo;&mdash;&mdash;字符串返回；<br />
&ldquo;number&rdquo;&mdash;&mdash;数值类型值返回；<br />
&ldquo;object&rdquo;&mdash;&mdash;Object类型或者Null类型均返回；<br />
&ldquo;function&rdquo;&mdash;&mdash;函数返回；</pre>
</div>
<p>下面是简单测试：</p>
<div>
<pre class="prettyprint linenums">var m1 = "message",m2 = true,m3 = 98,m4,m5 = {},m6 = null,m7 = function(){};

console.log(typeof m1);<br />
console.log(typeof m2);<br />
console.log(typeof m3);<br />
console.log(typeof m4);<br />
console.log(typeof m5);<br />
console.log(typeof m6);<br />
console.log(typeof m7);</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/798032/201609/798032-20160926104534313-971105243.png" /></p>
<p>Boolean类型的字面值true和false是区分大小写的，<strong>所有数据类型均可通过Boolean()转换函数转换为Boolean类型，对于Number类型，任何非零（包括无穷大）转换为true，0和NaN转换为false；对于Object类型来说，转换为true，null转换为false</strong></p>
<p><strong>关于NaN：</strong></p>
<p>NaN（Not a Number）即非数值，是一个特殊数值，NaN有2个特点：</p>
<ul><li><strong>任何涉及NaN的操作都会返回NaN</strong></li>
<li><strong>NaN与任何值都不相等，包括NaN本身</strong></li></ul>
<p>关于NaN的测试如下：</p>
<div>
<pre class="prettyprint linenums">console.log(NaN / 10);　　　　//NaN<br />
console.log(NaN / 0);　　　　　　//NaN<br />
console.log(NaN == NaN);　　　　//false<br />
console.log(isNaN(NaN));　　　　//true<br />
console.log(isNaN(""));　　　　//false<br />
console.log(isNaN(12));　　　　//false<br />
console.log(isNaN("awd"));　　　　//true<br />
console.log(isNaN("awd12"));　　　　//true<br />
console.log(isNaN("12awd"));　　　　//true<br />
console.log(isNaN(null));　　　　//false<br />
console.log(isNaN({}));　　　　　　//true　　<br />
console.log(isNaN({valueOf:function(){　　　　　　//<strong>false，如果是对象则调用其valueOf方法，查看返回是否匹配NaN<br />
  </strong>return -1;<br />
}}));<br />
console.log(isNaN({valueOf:function(){　　　　　　//true<br />
  return "awdw";<br />
}}));</pre>
</div>
<p><strong>关于Number()函数：</strong></p>
<p><strong>Number()函数用于将一个非数值转换为数值类型，Boolean直接返回1或0，null返回0，undefined返回NaN，如果是字符串：空字符串返回0，非空返回去除前导0的字符值，比如"011"返回11，如果非数值字符串返回NaN，比如"this is test"返回NaN；如果是对象，则调用对象的valueOf方法返回。</strong></p>
<p><strong>关于Object类型：</strong></p>
<p>创建：</p>
<div>
<pre class="prettyprint linenums">var o = new Object();</pre>
</div>
<p>Object的每个实例都有如下属性和方法：</p>
<ul><li>constructor：保存着用于创建当前对象的函数</li>
<li>isPrototypeOf(object)：用于检查传入的对象是否是传入对象的原型</li>
<li>hasOwnProperty(propertyName)：用于检查给定的属性是否在当前对象实例中</li>
<li>propertyIsEnumerable(propertyName)：用于检查给定的属性是否能够使用for-in 语句枚举<em><br /></em></li>
<li>toLocaleString()：返回对象的字符串表示，该字符串与执行环境的地区对应</li>
<li>toString()：返回对象的字符串表示</li>
<li>valueOf()：返回对象的字符串、数值或布尔值表示</li></ul>
<p><strong>4、函数类型</strong></p>
<p>ECMAScript的函数支持不定参数，实际上通过arguments对象即可直接获取请求的参数，函数定义时可以不用指定参数，使用时也可以传入任意数量参数：</p>
<div>
<pre class="prettyprint linenums">function say(){<br />
  for(var i=0,len=arguments.length;i&lt;len;i++){<br />
    console.log(arguments[i]);<br />
  }<br />
}

say(12,"343","1231");</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/798032/201609/798032-20160926120943500-1572115736.png" /></p>
<div>
<pre class="prettyprint linenums">function say2(name,age){<br />
  console.log(name);<br />
  console.log(name == arguments[0]);<br />
  console.log(age);<br />
  console.log(age == arguments[1]);<br />
}

say2("admin",23);</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/798032/201609/798032-20160926121149516-602398237.png" /></p>
<p><strong>ECMAScript的函数不支持重载，如果定义了2个同名函数，则第二个会覆盖第一个函数：</strong></p>
<div>
<pre class="prettyprint linenums">function say(){<br />
  console.log(1111);<br />
}

say();　　　　　　//2222

function say(){<br />
  console.log(2222);　　　　　　<br />
}

say();　　　　　　//2222</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1jxzqg.html">T-SQL学习记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvv7o1q.html">滑动验证的设计与实现J2EE</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qydz1xq.html">嵌入式 Linux下永久生效环境变量bashrc</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdlp5z8.html">oracle 10g编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q736jj8.html">Hash Table in C</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7wpvj9.html">&lbrack;Android Rro&rsqb; SDK JAR</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k763j9.html">easyui plugin&mdash;&mdash;etreegrid：CRUD Treegrid</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq401258.html">cmd窗口编码方式的修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xw3ez8.html">OC面向对象封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvrr5xq.html">剑指offer--面试题12</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okenj9.html">SQL Server 2008 R2 制作数据库结构和数据脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmry1q.html">GeoPandas官方中文文档--译著</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn06ypq.html">POJ 1845</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzel2w8.html">&period;net文件上传，客户端用jquery file upload</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw33k9.html">SVN的目录管理规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/950kzg68.html">ruby技巧001&colon;求md5散列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp70459.html">javascript中Date常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geop3l8.html">WPF 10天修炼 第十天- WPF数据绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpvev8.html">python3 set（集合）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oxegg8.html">Java集合源码分析之LinkedList</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q750o19.html">js灵活打印web页面区域内容的通用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdyrkzq.html">mybatis（二）接口编程 、动态sql 、批量删除 、动态更新、连表查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4o30e8.html">Java中abstract的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g7ro49.html">iOS  button  里边的 字体的 摆放</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4o6zj8.html">基于Java的WebSocket推送【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy7o0mq.html">&lbrack;算法&rsqb;树上倍增求LCA</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnxkd29.html">BigDecimal类的加减乘除</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvypezq.html">each函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9341on8.html">20145225  《Java程序设计》 第3周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p4on49.html">递推 N矩形问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
